<?php namespace AntiMalware\Tests;

use Ollyxar\AntiMalware\Scanner;
use PHPUnit\Framework\TestCase;

class TScanner extends Scanner
{
    public function scanFile($file, $report = true)
    {
        return parent::scanFile($file, $report);
    }
}

class ScanTest extends TestCase
{
    private $files = [];

    protected function getFiles($dir)
    {
        if (is_dir($dir)) {
            $files = scandir($dir);

            foreach ($files as $file) {
                if ($file != "." && $file != "..") {
                    if (is_dir($dir . "/" . $file)) {
                        $this->getFiles($dir . "/" . $file);
                    } else {
                        $this->files[] = $dir . "/" . $file;
                    }
                }
            }
        }
    }

    public function testScan()
    {
        $this->getFiles(dirname(__FILE__) . '/samples');
        $scanner = new TScanner(dirname(__FILE__) . '/samples', ['txt']);

        foreach ($this->files as $file) {
            $result = $scanner->scanFile($file, false);

            if (strpos($file, '/samples/positive/') !== false) {
                $this->assertTrue(!empty($result));
            }

            if (strpos($file, '/samples/negative/') !== false) {
                $this->assertTrue(empty($result));
            }
        }
    }
}